Deployments API

To update a device with the configuration changes saved in your WatchGuard Cloud account, you must create a deployment for the device. Each deployment creates a transaction record, which includes details of the deployment.

When you create a deployment for a device, all configuration changes saved in WatchGuard Cloud for that device will be deployed at the specified time. For example, if you used the Firebox Management API to delete a WebBlocker exception from WatchGuard Cloud for a device, the deployment deletes that exception from the device.

At the specified deployment time, WatchGuard Cloud notifies the device that configuration changes are available. The device then connects to WatchGuard Cloud, retrieves the configuration updates, and applies them. If the device is offline at the scheduled update time, it retrieves and applies the configuration updates the next time it connects to WatchGuard Cloud.

You can use the Firebox Management API to create deployments and retrieve transaction records. You can also update or cancel transactions for deployments that are scheduled to start in the future.

Endpoints:

/{v1}/commands/{accountid}/deployments

/{v1}/commands/{accountid}/transactions

/{v1}/commands/{accountid}/transactions/{objectid}

/{v1}/commands/{accountid}/transactions/{objectid}

/{v1}/commands/{accountid}/transactions/{objectid}

Create a New Device Deployment

/{v1}/commands/{accountid}/deployments

Make a request to this endpoint to deploy the configuration changes saved in WatchGuard Cloud to the specified devices. You can specify whether to deploy the configuration changes immediately or at a specific time in the future.

If you want to redeploy a previous deployment to the device, include the optional version parameter in your request. The Firebox Management API redeploys the deployment object with the specified version to the device. The transaction record for a specific device deployment includes the version number in the data parameter. For more information, see Retrieve a Transaction Record.

The response to this request includes a transaction record for the deployment. If you create a deployment for multiple devices, the Firebox Management API creates a parent transaction record and additional child transaction records for each device. For example, if you create a deployment for three devices, the response includes one parent transaction record and three child transaction records. The parent and children parameters in a transaction record include the IDs of related transactions.

Path Parameters

When you send a request to this endpoint, you must include these path parameters:

accountid
string
REQUIRED

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

Request Body

version
integer

Version number of the device deployment to deploy. Only specify a version if you want to redeploy a previous deployment to the device. This will override the previous deployment to the device.

Example: 1

start_date
string
REQUIRED

Time to deploy to the specified devices. Specify now to deploy immediately or specify a time in UTC format to deploy at that time.

Example: 2020-04-19T21:23:46Z

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

devices
array
REQUIRED

Device(s) to deploy to.

Each device has a unique ID number in WatchGuard Cloud, which appears in the URL of the Device Summary page. For example, if the Device Summary page URL is https://usa.cloud.watchguard.com/services/fb/device/FB-12345/summary, your device ID is FB-12345.

For standalone Fireboxes, specify only the numbers from the device ID. For example, 12345.

For FireClusters, specify the full device ID. For example, FBCL-12345.

Enclose in square brackets and separate device IDs with commas.

Example: [12345,12346,12347]

You can specify a maximum of 50 devices in the list.

Example Request

This request deploys the configuration changes saved in WatchGuard Cloud for device 12345 immediately:

            curl -X POST https://api.usa.cloud.watchguard.com/rest/firebox/management/v1/commands/WGC-1-123abc456/deployments 
	-H 'Accept: application/json'
	-H 'Content-Type: application/json' 
	-H 'WatchGuard-API-Key: s9t7El6RZFg8UcmRhYKdwXqBhyuioiWER83Nqd0tL'
	-H 'Authorization: Bearer eyJraWQiOiJNWnpabklNK2V6Q3BXUE5mM2FXTHhoSmEza0ltcEFMbnluT05DcFdIT2tZPSIsImFsZyI6IlJTMjU2In0.eyJzdWIiOiJjNDQyMTJlMi05MmI1LTRiOTYtYTRmNS1lYWRlODA4OTM1YjIiLCJjdXN0b206YXBpX2tleXMiOiJwMHM1UmQzUkF2NlR2d0VuWEx5YUphR2x0ZWtieEFVUzcwVGVzOXlGIiwiaXNzIjoiaHR0cHM6XC9cL2NvZ25pdG8taWRwLnVzLXdlc3QtMi5hbWF6b25hd3MuY29tXC91cy13ZXN0LTJfa3hXeFdrTFZ5IiwiY29nbml0bzp1c2VybmFtZSI6IjAyNjk0OWM1OWI2NzIxOGNfcndfaWQiLCJhdWQiOiIzb3AybDBqazkxN3FudXFoZnVoanRvcXRzZyIsImV2ZW50X2lkIjoiODczM2ZmMjktOGNhMC00ODMyLTg0NzgtMDNiNWIxMDI3NmQ3IiwidG9rZW5fdXNlIjoiaWQiLCJhdXRoX3RpbWUiOjE1NjkzNTM0NDEsIm5hbWUiOiIwMjY5NDljNTliNjcyMThjX3J3X2lkIiwiY3VzdG9tOmFjY291bnRfaWQiOiJBQ0MtMTIzNTA2OCIsImV4cCI6MTU2OTM1NzA0MSwiY3VzdG9tOnJvbGUiOiIxIiwiaWF0IjoxNTY5MzUzNDQxfQ.MUAeG6QyM7Zog8mM--WK2uJVevLRwz8z2KPpGhQbUnHK04Hy_JdO4F4wH6IV0WVENGsBrcjp5boxcBZgdJE46123MGnB0HvghN5IoAZUOkfFPm7SAN68posHqYLoo14YNedc5GtvOzCxTmi9YepvE5LhsoC6Tgyc0e3ABn18gEZsyxmJFcMBHXOMei7AssYSWAdDyoI7j6jZslxmhXj7_h6T9PyqjLxLjFEq5S6oK9u4IVDVBlRxbURaRVAGb7ywfHiZEPDgceV-Wnv0AIhDzj5dL28AmiGIkWtWinF0UD-NSMKN4vtszK2sUWUSl8ZfVNGU650heiAaUAy7XmiqbA'
	-d '{
	"start_date": "now",
	"description": "Deploy exceptions to Seattle office",
	"devices":[12345]
	}'
        

Example Response

The response includes a list of transaction records for the deployment:

                [
    {
        "account": "WGC-1-4b0079544acb4248be33",
        "author": "",
        "author_username": "",
        "created": 1723169573,
        "deployment_version": 17,
        "description": "Deploy exceptions to Seattle office Fireboxes.",
        "device": "101292",
        "id": "ddply_101292_BR5yl5o5KCAymR9",
        "inception_time": 1723169573,
        "metadata": {
            "device_asof": "2024-08-09T02:12:53Z",
            "new_flow": true
        },
        "object": "device_deployment",
        "original_author": "",
        "original_author_username": "",
        "referencedby": [],
        "references": [],
        "start_date": "now",
        "status": "imaged",
        "version": 2
    }
]
            

This table lists and describes the data returned in the response:

account
string

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

original_author_username
string

Operator that added the transaction. This is always empty for transactions added with the Firebox Management API.

id
string

Unique ID that identifies this transaction. This includes the time when the deployment will occur, in Unix epoch time format. For parent transactions, the ID includes the text "parent". For child transactions, the ID includes the device id.

Example: ddply_12345_J2VwPbXuek3CRGN1

status
string

Status of the transaction. This can be one of these statuses:

  • scheduled — Deployment is scheduled to start at the time specified by the start_date parameter.
  • pending — Deployment executed but the device has not retrieved the configuration changes yet.
  • in_progress — Deployment executed and the device is retrieving the configuration changes.
  • complete — Deployment executed and the device successfully retrieved the configuration changes.
  • failed — Deployment failed.
  • imaged — A pending or in progress deployment timed out.

Example: complete

start_date
string

Time to deploy the transaction to the device, in UTC format.

Example: 2020-02-21T19:48:19Z

object
string

Device object type.

Example: device_deployment

device
string

Device this transaction applies to. Each device has a unique ID number in WatchGuard Cloud that appears in the URL of the Device Summary page.

Example: 12345

inception_time
integer

Time that the transaction was created, in seconds since epoch.

Example: 1714684162

created
string

Time that the transaction was created, in UTC format.

Example: 1723169573

deployment_version
string

Version number of the deployment.

Example: 17

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

Query All Transaction Records

/{v1}/commands/{accountid}/transactions/

Make a request to this endpoint to retrieve all transaction records, which include details of individual deployments.

Path Parameters

When you send a request to this endpoint, you must include these path parameters:

accountid
string
REQUIRED

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

Request Parameters

When you send a request to this endpoint, you can include these request parameters:

device
integer
string

Device to retrieve transaction records for.

Each device has a unique ID number in WatchGuard Cloud, which appears in the URL of the Device Summary page. For example, if the Device Summary page URL is https://usa.cloud.watchguard.com/services/fb/device/FB-12345/summary, your device ID is FB-12345.

For standalone Fireboxes, specify only the numbers from the device ID. For example, 12345.

For FireClusters, specify the full device ID. For example, FBCL-12345.

Example: 12345, FBCL-12345

tx_type
string
REQUIRED

Specifies the type of transaction records to retrieve.

Example: deployment

Example Request

This request retrieves the transaction records for the device with an id of 12345.

            curl -X GET https://api.usa.cloud.watchguard.com/rest/firebox/management/v1/commands/WGC-1-123abc456/transactions?device=12345&tx_type=deployment 
	-H 'Accept: application/json'
	-H 'Content-Type: application/json' 
	-H 'WatchGuard-API-Key: s9t7El6RZFg8UcmRhYKdwXqBhyuioiWER83Nqd0tL'
	-H 'Authorization: Bearer eyJraWQiOiJNWnpabklNK2V6Q3BXUE5mM2FXTHhoSmEza0ltcEFMbnluT05DcFdIT2tZPSIsImFsZyI6IlJTMjU2In0.eyJzdWIiOiJjNDQyMTJlMi05MmI1LTRiOTYtYTRmNS1lYWRlODA4OTM1YjIiLCJjdXN0b206YXBpX2tleXMiOiJwMHM1UmQzUkF2NlR2d0VuWEx5YUphR2x0ZWtieEFVUzcwVGVzOXlGIiwiaXNzIjoiaHR0cHM6XC9cL2NvZ25pdG8taWRwLnVzLXdlc3QtMi5hbWF6b25hd3MuY29tXC91cy13ZXN0LTJfa3hXeFdrTFZ5IiwiY29nbml0bzp1c2VybmFtZSI6IjAyNjk0OWM1OWI2NzIxOGNfcndfaWQiLCJhdWQiOiIzb3AybDBqazkxN3FudXFoZnVoanRvcXRzZyIsImV2ZW50X2lkIjoiODczM2ZmMjktOGNhMC00ODMyLTg0NzgtMDNiNWIxMDI3NmQ3IiwidG9rZW5fdXNlIjoiaWQiLCJhdXRoX3RpbWUiOjE1NjkzNTM0NDEsIm5hbWUiOiIwMjY5NDljNTliNjcyMThjX3J3X2lkIiwiY3VzdG9tOmFjY291bnRfaWQiOiJBQ0MtMTIzNTA2OCIsImV4cCI6MTU2OTM1NzA0MSwiY3VzdG9tOnJvbGUiOiIxIiwiaWF0IjoxNTY5MzUzNDQxfQ.MUAeG6QyM7Zog8mM--WK2uJVevLRwz8z2KPpGhQbUnHK04Hy_JdO4F4wH6IV0WVENGsBrcjp5boxcBZgdJE46123MGnB0HvghN5IoAZUOkfFPm7SAN68posHqYLoo14YNedc5GtvOzCxTmi9YepvE5LhsoC6Tgyc0e3ABn18gEZsyxmJFcMBHXOMei7AssYSWAdDyoI7j6jZslxmhXj7_h6T9PyqjLxLjFEq5S6oK9u4IVDVBlRxbURaRVAGb7ywfHiZEPDgceV-Wnv0AIhDzj5dL28AmiGIkWtWinF0UD-NSMKN4vtszK2sUWUSl8ZfVNGU650heiAaUAy7XmiqbA'
        

Example Response

The response includes the transaction records that match the query:

                {
    "count": 887,
    "more": false,
    "objects": [
        {
            "account": "WGC-1-4b0079544acb4248be33",
            "author": "",
            "author_username": "",
            "confirmed_date": "2024-07-30T08:21:11Z",
            "created": 1722327674,
            "deployment_version": 45,
            "description": "Template subscription update",
            "device": "100243",
            "id": "ddply_100243_03vvNbGqJr1OxrE",
            "inception_time": 1722327662,
            "metadata": {
                "device_asof": "2024-07-19T16:26:06Z",
                "hold_reason": null,
                "new_flow": true,
                "prev_ddply": "ddply_100243_TpXxgZZiFT2lNbT",
                "prev_version": "ddply_100243_TpXxgZZiFT2lNbT",
                "source": "brainiac",
                "subscription_change": true,
                "template_initiated": true,
                "tmpl_data": {
                    "author": "C5WwdZDUEUOOG+HyPui1MA==",
                    "author_username": "fccm-qa-owner",
                    "subscribe_templates": [
                        "WGC-1-4b0079544acb4248be33/tmpl_100243_ztZxPlAPY67XhVic"
                    ]
                }
            },
            "object": "device_deployment",
            "original_author": "",
            "original_author_username": "",
            "referencedby": [],
            "references": [],
            "start_date": "2024-07-30T08:21:02Z",
            "status": "complete",
            "version": 1
        },
        {
            "account": "WGC-1-4b0079544acb4248be33",
            "author": "",
            "author_username": "",
            "confirmed_date": "2024-07-17T04:02:17Z",
            "created": 1721189001,
            "deployment_version": 25,
            "description": "Deploy exceptions to Seattle office Fireboxes.",
            "device": "100243",
            "id": "ddply_100243_1p25JB2Po2y1BOz",
            "inception_time": 1721188862,
            "metadata": {
                "device_asof": "2024-07-17T04:01:02Z",
                "hold_reason": null,
                "initial": true,
                "new_flow": true,
                "scope": "FB"
            },
            "object": "device_deployment",
            "original_author": "C5WwdZDUEUOOG+HyPui1MA==",
            "original_author_username": "fccm-qa-owner",
            "referencedby": [],
            "references": [],
            "start_date": "2024-07-17T04:01:02Z",
            "status": "complete",
            "version": 2
        },
        {
            "account": "WGC-1-4b0079544acb4248be33",
            "author": "",
            "author_username": "",
            "confirmed_date": "2024-07-15T06:07:07Z",
            "created": 1721023630,
            "deployment_version": 21,
            "description": "Deploy exceptions to Seattle office Fireboxes.",
            "device": "100243",
            "id": "ddply_100243_2EkJ5xo7yYGsOH0",
            "inception_time": 1721023618,
            "metadata": {
                "device_asof": "2024-07-15T06:06:58Z",
                "hold_reason": null,
                "new_flow": true,
                "scope": "FB"
            },
            "object": "device_deployment",
            "original_author": "C5WwdZDUEUOOG+HyPui1MA==",
            "original_author_username": "fccm-qa-owner",
            "referencedby": [],
            "references": [],
            "start_date": "2024-07-15T06:06:58Z",
            "status": "complete",
            "version": 2
        }
            

This table lists and describes the data returned in the response:

account
string

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

original_author_username
string

Operator that added the transaction. This is always empty for transactions added with the Firebox Management API.

id
string

Unique ID that identifies this transaction. This includes the time when the deployment will occur, in Unix epoch time format. For parent transactions, the ID includes the text "parent". For child transactions, the ID includes the device id.

Example: ddply_12345_J2VwPbXuek3CRGN1

status
string

Status of the transaction. This can be one of these statuses:

  • scheduled — Deployment is scheduled to start at the time specified by the start_date parameter.
  • pending — Deployment executed but the device has not retrieved the configuration changes yet.
  • in_progress — Deployment executed and the device is retrieving the configuration changes.
  • complete — Deployment executed and the device successfully retrieved the configuration changes.
  • failed — Deployment failed.
  • imaged — A pending or in progress deployment timed out.

Example: complete

start_date
string

Time to deploy the transaction to the device, in UTC format.

Example: 2020-02-21T19:48:19Z

object
string

Device object type.

Example: device_deployment

device
string

Device this transaction applies to. Each device has a unique ID number in WatchGuard Cloud that appears in the URL of the Device Summary page.

Example: 12345

inception_time
integer

Time that the transaction was created, in seconds since epoch.

Example: 1714684162

created
string

Time that the transaction was created, in UTC format.

Example: 1723169573

deployment_version
string

Version number of the deployment.

Example: 17

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

Retrieve a Transaction Record

/{v1}/commands/{accountid}/transactions/{objectid}

Make a request to this endpoint to retrieve the specified transaction record, which includes details of a specific deployment.

Path Parameters

When you send a request to this endpoint, you must include these path parameters:

accountid
string
REQUIRED

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

objectid
string
REQUIRED

ID of the transaction record to retrieve.

Example: ddply_12345_J2VwPbXuek3CRGN1

Example Request

This request retrieves the transaction record with an objectid of ddply_12345_J2VwPbXuek3CRGN1.

            curl -X GET https://api.usa.cloud.watchguard.com/rest/firebox/management/v1/commands/WGC-1-123abc456/transactions/ddply_12345_J2VwPbXuek3CRGN1 
	-H 'Accept: application/json'
	-H 'Content-Type: application/json' 
	-H 'WatchGuard-API-Key: s9t7El6RZFg8UcmRhYKdwXqBhyuioiWER83Nqd0tL'
	-H 'Authorization: Bearer eyJraWQiOiJNWnpabklNK2V6Q3BXUE5mM2FXTHhoSmEza0ltcEFMbnluT05DcFdIT2tZPSIsImFsZyI6IlJTMjU2In0.eyJzdWIiOiJjNDQyMTJlMi05MmI1LTRiOTYtYTRmNS1lYWRlODA4OTM1YjIiLCJjdXN0b206YXBpX2tleXMiOiJwMHM1UmQzUkF2NlR2d0VuWEx5YUphR2x0ZWtieEFVUzcwVGVzOXlGIiwiaXNzIjoiaHR0cHM6XC9cL2NvZ25pdG8taWRwLnVzLXdlc3QtMi5hbWF6b25hd3MuY29tXC91cy13ZXN0LTJfa3hXeFdrTFZ5IiwiY29nbml0bzp1c2VybmFtZSI6IjAyNjk0OWM1OWI2NzIxOGNfcndfaWQiLCJhdWQiOiIzb3AybDBqazkxN3FudXFoZnVoanRvcXRzZyIsImV2ZW50X2lkIjoiODczM2ZmMjktOGNhMC00ODMyLTg0NzgtMDNiNWIxMDI3NmQ3IiwidG9rZW5fdXNlIjoiaWQiLCJhdXRoX3RpbWUiOjE1NjkzNTM0NDEsIm5hbWUiOiIwMjY5NDljNTliNjcyMThjX3J3X2lkIiwiY3VzdG9tOmFjY291bnRfaWQiOiJBQ0MtMTIzNTA2OCIsImV4cCI6MTU2OTM1NzA0MSwiY3VzdG9tOnJvbGUiOiIxIiwiaWF0IjoxNTY5MzUzNDQxfQ.MUAeG6QyM7Zog8mM--WK2uJVevLRwz8z2KPpGhQbUnHK04Hy_JdO4F4wH6IV0WVENGsBrcjp5boxcBZgdJE46123MGnB0HvghN5IoAZUOkfFPm7SAN68posHqYLoo14YNedc5GtvOzCxTmi9YepvE5LhsoC6Tgyc0e3ABn18gEZsyxmJFcMBHXOMei7AssYSWAdDyoI7j6jZslxmhXj7_h6T9PyqjLxLjFEq5S6oK9u4IVDVBlRxbURaRVAGb7ywfHiZEPDgceV-Wnv0AIhDzj5dL28AmiGIkWtWinF0UD-NSMKN4vtszK2sUWUSl8ZfVNGU650heiAaUAy7XmiqbA'
        

Example Response

The response includes the specified transaction record:

                {
    "account": "WGC-1-4b0079544acb4248be33",
    "author": "",
    "author_username": "",
    "confirmed_date": "2024-08-09T02:12:57Z",
    "created": 1723169579,
    "deployment_version": 17,
    "description": "Deploy exceptions to Seattle office Fireboxes.",
    "device": "101292",
    "id": "ddply_101292_BR5yl5o5KCAymR9",
    "inception_time": 1723169573,
    "metadata": {
        "device_asof": "2024-08-09T02:12:53Z",
        "hold_reason": null,
        "new_flow": true
    },
    "object": "device_deployment",
    "original_author": "",
    "original_author_username": "",
    "referencedby": [],
    "references": [],
    "start_date": "2024-08-09T02:12:53Z",
    "status": "complete",
    "version": 2
}
            

This table lists and describes the data returned in the response:

account
string

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

original_author_usernameoperator
string

Operator that added the transaction. This is always empty for transactions added with the Firebox Management API.

id
string

Unique ID that identifies this transaction. This includes the time when the deployment will occur, in Unix epoch time format. For parent transactions, the ID includes the text "parent". For child transactions, the ID includes the device id.

Examples:

ddply_12345_J2VwPbXuek3CRGN1deployment_12345_1582314499_zRmCUMqFghS5oCLmRcWtshBI

deployment_parent_1583862246_IfKUIDAZAs8uEJAYYF6eDDuL

status
string

Status of the transaction. This can be one of these statuses:

  • scheduled — Deployment is scheduled to start at the time specified by the start_date parameter.
  • pending — Deployment executed but the device has not retrieved the configuration changes yet.
  • in_progress — Deployment executed and the device is retrieving the configuration changes.
  • complete — Deployment executed and the device successfully retrieved the configuration changes.
  • failed — Deployment failed.
  • imagedtimed_out — A pending or in progress deployment timed out.
  • canceled — Transaction record was deleted before the deployment executed.

Example: complete

start_date
string

Time to deploy the transaction to the device, in UTC format.

Example: 2020-02-21T19:48:19Z

objecttype
string

Device object transaction type.

Example: device_deployment

device
string

Device this transaction applies to. Each device has a unique ID number in WatchGuard Cloud that appears in the URL of the Device Summary page.

Example: 12345

inception_time
integers

Time that the transaction was created, in seconds since epoch.

Example: 1714684162

created
string

Time that the transaction was created, in UTC format.

Example: 1723169573

deployment_version
string

Version number of the deployment.

Example: 17

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

Update a Transaction

/{v1}/commands/{accountid}/transactions/{objectid}

Make a request to this endpoint to update the start date of the specified transaction, which includes details of a specific deployment. Optionally, you can also update the description of the transaction.

You can only update scheduled transactions with a start date in the future.

Path Parameters

When you send a request to this endpoint, you must include these path parameters:

accountid
string
REQUIRED

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

objectid
string
REQUIRED

ID of the transaction record to update.

Example: ddply_12345_J2VwPbXuek3CRGN1

Request Body

start_date
string
REQUIRED

Time to deploy to the specified devices. Specify now to deploy immediately or specify a time in UTC format to deploy at that time.

Example: 2020-04-19T21:23:46Z

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

Example Request

This request updates the start_date and description of the transaction with an objectid of ddply_12345_J2VwPbXuek3CRGN1.

            curl -X PUT https://api.usa.cloud.watchguard.com/rest/firebox/management/v1/commands/WGC-1-123abc456/transactions/ddply_12345_J2VwPbXuek3CRGN1 
	-H 'Accept: application/json'
	-H 'Content-Type: application/json' 
	-H 'WatchGuard-API-Key: s9t7El6RZFg8UcmRhYKdwXqBhyuioiWER83Nqd0tL'
	-H 'Authorization: Bearer eyJraWQiOiJNWnpabklNK2V6Q3BXUE5mM2FXTHhoSmEza0ltcEFMbnluT05DcFdIT2tZPSIsImFsZyI6IlJTMjU2In0.eyJzdWIiOiJjNDQyMTJlMi05MmI1LTRiOTYtYTRmNS1lYWRlODA4OTM1YjIiLCJjdXN0b206YXBpX2tleXMiOiJwMHM1UmQzUkF2NlR2d0VuWEx5YUphR2x0ZWtieEFVUzcwVGVzOXlGIiwiaXNzIjoiaHR0cHM6XC9cL2NvZ25pdG8taWRwLnVzLXdlc3QtMi5hbWF6b25hd3MuY29tXC91cy13ZXN0LTJfa3hXeFdrTFZ5IiwiY29nbml0bzp1c2VybmFtZSI6IjAyNjk0OWM1OWI2NzIxOGNfcndfaWQiLCJhdWQiOiIzb3AybDBqazkxN3FudXFoZnVoanRvcXRzZyIsImV2ZW50X2lkIjoiODczM2ZmMjktOGNhMC00ODMyLTg0NzgtMDNiNWIxMDI3NmQ3IiwidG9rZW5fdXNlIjoiaWQiLCJhdXRoX3RpbWUiOjE1NjkzNTM0NDEsIm5hbWUiOiIwMjY5NDljNTliNjcyMThjX3J3X2lkIiwiY3VzdG9tOmFjY291bnRfaWQiOiJBQ0MtMTIzNTA2OCIsImV4cCI6MTU2OTM1NzA0MSwiY3VzdG9tOnJvbGUiOiIxIiwiaWF0IjoxNTY5MzUzNDQxfQ.MUAeG6QyM7Zog8mM--WK2uJVevLRwz8z2KPpGhQbUnHK04Hy_JdO4F4wH6IV0WVENGsBrcjp5boxcBZgdJE46123MGnB0HvghN5IoAZUOkfFPm7SAN68posHqYLoo14YNedc5GtvOzCxTmi9YepvE5LhsoC6Tgyc0e3ABn18gEZsyxmJFcMBHXOMei7AssYSWAdDyoI7j6jZslxmhXj7_h6T9PyqjLxLjFEq5S6oK9u4IVDVBlRxbURaRVAGb7ywfHiZEPDgceV-Wnv0AIhDzj5dL28AmiGIkWtWinF0UD-NSMKN4vtszK2sUWUSl8ZfVNGU650heiAaUAy7XmiqbA'
	-d '{
	"start_date": "2020-06-1T21:23:46Z",
	"description": "Deploy to Seattle office Firebox"
	}'
        

Example Response

The response includes the updated transaction record:

                {
    "account": "WGC-1-4b0079544acb4248be33",
    "author": "",
    "author_username": "",
    "created": 1723169955,
    "description": "Deploy exceptions to Seattle office Fireboxes.",
    "device": "101292",
    "id": "ddply_101292_v02rOiK5UOXKafo",
    "inception_time": 1723169914,
    "metadata": {
        "job_id": 175790,
        "job_name": "ddply_101292_v02rOiK5UOXKafo_1723169914",
        "new_flow": true
    },
    "object": "device_deployment",
    "original_author": "",
    "original_author_username": "",
    "referencedby": [],
    "references": [],
    "start_date": "2024-08-10T06:00:00Z",
    "status": "scheduled",
    "version": 3
}
            

This table lists and describes the data returned in the response:

account
string

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

original_author_username
string

Operator that added the transaction. This is always empty for transactions added with the Firebox Management API.

id
string

Unique ID that identifies this transaction. This includes the time when the deployment will occur, in Unix epoch time format. For parent transactions, the ID includes the text "parent". For child transactions, the ID includes the device id.

Example: ddply_12345_J2VwPbXuek3CRGN1

status
string

Status of the transaction. This can be one of these statuses:

  • scheduled — Deployment is scheduled to start at the time specified by the start_date parameter.
  • pending — Deployment executed but the device has not retrieved the configuration changes yet.
  • in_progress — Deployment executed and the device is retrieving the configuration changes.
  • complete — Deployment executed and the device successfully retrieved the configuration changes.
  • failed — Deployment failed.
  • imaged — A pending or in progress deployment timed out.

Example: complete

start_date
string

Time to deploy the transaction to the device, in UTC format.

Example: 2020-02-21T19:48:19Z

object
string

Device object type.

Example: device_deployment

device
string

Device this transaction applies to. Each device has a unique ID number in WatchGuard Cloud that appears in the URL of the Device Summary page.

Example: 12345

inception_time
integer

Time that the transaction was created, in seconds since epoch.

Example: 1714684162

created
string

Time that the transaction was created, in UTC format.

Example: 1723169573

deployment_version
string

Version number of the deployment.

Example: 17

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.

Cancel a Transaction

/{v1}/commands/{accountid}/transactions/{objectid}

Make a request to this endpoint to cancel the specified transaction, which includes details of a specific deployment. You might cancel a transaction if you decide that you do not want to deploy the configuration changes it includes to a device. Devices do not retrieve canceled transactions.

You can only cancel transactions that have not yet deployed to a device, such as those with a status of pending or scheduled.

Transaction records for canceled transactions have a status of canceled and remain in the database.

Path Parameters

When you send a request to this endpoint, you must include these path parameters:

accountid
string
REQUIRED

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

objectid
string
REQUIRED

ID of the transaction record to cancel.

Example: ddply_12345_J2VwPbXuek3CRGN1

Example Request

This request cancels the transaction with an objectid of ddply_12345_J2VwPbXuek3CRGN1.

            curl -X DELETE https://api.usa.cloud.watchguard.com/rest/firebox/management/v1/commands/WGC-1-123abc456/transactions/ddply_12345_J2VwPbXuek3CRGN1 
	-H 'Accept: application/json'
	-H 'Content-Type: application/json' 
	-H 'WatchGuard-API-Key: s9t7El6RZFg8UcmRhYKdwXqBhyuioiWER83Nqd0tL'
	-H 'Authorization: Bearer eyJraWQiOiJNWnpabklNK2V6Q3BXUE5mM2FXTHhoSmEza0ltcEFMbnluT05DcFdIT2tZPSIsImFsZyI6IlJTMjU2In0.eyJzdWIiOiJjNDQyMTJlMi05MmI1LTRiOTYtYTRmNS1lYWRlODA4OTM1YjIiLCJjdXN0b206YXBpX2tleXMiOiJwMHM1UmQzUkF2NlR2d0VuWEx5YUphR2x0ZWtieEFVUzcwVGVzOXlGIiwiaXNzIjoiaHR0cHM6XC9cL2NvZ25pdG8taWRwLnVzLXdlc3QtMi5hbWF6b25hd3MuY29tXC91cy13ZXN0LTJfa3hXeFdrTFZ5IiwiY29nbml0bzp1c2VybmFtZSI6IjAyNjk0OWM1OWI2NzIxOGNfcndfaWQiLCJhdWQiOiIzb3AybDBqazkxN3FudXFoZnVoanRvcXRzZyIsImV2ZW50X2lkIjoiODczM2ZmMjktOGNhMC00ODMyLTg0NzgtMDNiNWIxMDI3NmQ3IiwidG9rZW5fdXNlIjoiaWQiLCJhdXRoX3RpbWUiOjE1NjkzNTM0NDEsIm5hbWUiOiIwMjY5NDljNTliNjcyMThjX3J3X2lkIiwiY3VzdG9tOmFjY291bnRfaWQiOiJBQ0MtMTIzNTA2OCIsImV4cCI6MTU2OTM1NzA0MSwiY3VzdG9tOnJvbGUiOiIxIiwiaWF0IjoxNTY5MzUzNDQxfQ.MUAeG6QyM7Zog8mM--WK2uJVevLRwz8z2KPpGhQbUnHK04Hy_JdO4F4wH6IV0WVENGsBrcjp5boxcBZgdJE46123MGnB0HvghN5IoAZUOkfFPm7SAN68posHqYLoo14YNedc5GtvOzCxTmi9YepvE5LhsoC6Tgyc0e3ABn18gEZsyxmJFcMBHXOMei7AssYSWAdDyoI7j6jZslxmhXj7_h6T9PyqjLxLjFEq5S6oK9u4IVDVBlRxbURaRVAGb7ywfHiZEPDgceV-Wnv0AIhDzj5dL28AmiGIkWtWinF0UD-NSMKN4vtszK2sUWUSl8ZfVNGU650heiAaUAy7XmiqbA'
        

Example Response

The response includes the canceled transaction record:

                {
    "account": "WGC-1-4b0079544acb4248be33",
    "author": "",
    "author_username": "",
    "created": 1723169986,
    "description": "Deploy exceptions to Seattle office Fireboxes.",
    "device": "101292",
    "id": "ddply_101292_v02rOiK5UOXKafo",
    "inactive": true,
    "inception_time": 1723169914,
    "metadata": {
        "job_id": 175790,
        "job_name": "ddply_101292_v02rOiK5UOXKafo_1723169914",
        "new_flow": true
    },
    "object": "device_deployment",
    "original_author": "",
    "original_author_username": "",
    "referencedby": [],
    "references": [],
    "start_date": "2024-08-10T06:00:00Z",
    "status": "scheduled",
    "version": 4
}
            

This table lists and describes the data returned in the response:

account
string

Your WatchGuard Cloud account ID. You can see your accountId on the My Account page in WatchGuard Cloud.

Example: WGC-1-123abc456 or ACC-1234567

original_author_username
string

Operator that added the transaction. This is always empty for transactions added with the Firebox Management API.

id
string

Unique ID that identifies this transaction. This includes the time when the deployment will occur, in Unix epoch time format. For parent transactions, the ID includes the text "parent". For child transactions, the ID includes the device id.

Example: ddply_12345_J2VwPbXuek3CRGN1

status
string

Status of the transaction. This can be one of these statuses:

  • scheduled — Deployment is scheduled to start at the time specified by the start_date parameter.
  • pending — Deployment executed but the device has not retrieved the configuration changes yet.
  • in_progress — Deployment executed and the device is retrieving the configuration changes.
  • complete — Deployment executed and the device successfully retrieved the configuration changes.
  • failed — Deployment failed.
  • imaged — A pending or in progress deployment timed out.

Example: complete

start_date
string

Time to deploy the transaction to the device, in UTC format.

Example: 2020-02-21T19:48:19Z

object
string

Device object type.

Example: device_deployment

device
string

Device this transaction applies to. Each device has a unique ID number in WatchGuard Cloud that appears in the URL of the Device Summary page.

Example: 12345

inception_time
integer

Time that the transaction was created, in seconds since epoch.

Example: 1714684162

created
string

Time that the transaction was created, in UTC format.

Example: 1723169573

deployment_version
string

Version number of the deployment.

Example: 17

description
string

Description of the device deployment. Maximum: 128 characters.

Example: Deploy exceptions to Seattle office Fireboxes.